.\"	$NetBSD: humanize_number.9,v 1.7 2005/12/26 19:48:12 perry Exp $
.\"
.\" Copyright (c) 1999 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Luke Mewburn.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd May 21, 1999
.Dt HUMANIZE_NUMBER 9
.Os
.Sh NAME
.Nm humanize_number ,
.Nm format_bytes
.Nd format a number into a human readable form
.Sh SYNOPSIS
.Ft int
.Fo humanize_number
.Fa "char *buf" "size_t len" "uint64_t number" "const char *suffix"
.Fa "int divisor"
.Fc
.Ft int
.Fn format_bytes "char *buf" "size_t len" "uint64_t number"
.Sh DESCRIPTION
.Ss humanize_number
The
.Fn humanize_number
function formats the unsigned 64 bit quantity given in
.Fa number
into
.Fa buffer .
A space and then
.Fa suffix
is appended to the end.
.Fa buffer
must be at least
.Fa len
bytes long.
.Pp
If the formatted number (including
.Fa suffix )
would be too long to fit into
.Fa buffer ,
then divide
.Fa number
by
.Fa divisor
until it will.
In this case, prefix
.Fa suffix
with the appropriate SI designator.
Suitable values of
.Fa divisor
are 1024 or 1000 to remain consistent with the common meanings of the
SI designator prefixes.
.Pp
The prefixes are:
.Bl -column "Prefix" "Description" "Multiplier" -offset indent
.It Sy "Prefix" Ta Sy "Description" Ta Sy "Multiplier"
.It k	kilo	1024
.It M	mega	1048576
.It G	giga	1073741824
.It T	tera	1099511627776
.It P	peta	1125899906842624
.It E	exa	1152921504606846976
.El
.Pp
.Fa len
must be at least 4 plus the length of
.Fa suffix ,
in order to ensure a useful result is generated into
.Fa buffer .
.Ss format_bytes
The
.Fn format_bytes
function
is a front-end to
.Fn humanize_number
that calls the latter with a
.Fa suffix
of
.Dq B .
Also, if the suffix in the returned
.Fa buffer
would not have a prefix, remove the suffix.
This means that a result of
.Dq 100000
occurs, instead of
.Dq 100000 B .
.Sh RETURN VALUES
.Fn humanize_number
and
.Fn format_bytes
return the number of characters stored in
.Fa buffer
(excluding the terminating NUL) upon success, or \-1 upon failure.
.Sh HISTORY
.Fn humanize_number
and
.Fn format_bytes
first appeared in
.Nx 1.5 .
